/**************************************************************
 * Filename: links.c
 * SccsId:   see below
 *
 *************************************************************/
/*
 *	(c) Parsytec GmbH 1989
 *
 *	This program displays the status for all links in this maschine
 */
 

#include <stdio.h>
#include <sys/types.h>
#include "../link_c/link.h"


static char *SccsId = "@(#)links.c	1.2	94/12/07";	/* Sccs Id */

/* external function declarations */

extern	int OpenLink  ();	/* (Name); */
extern	int CloseLink ();	/* (LinkId); */
extern	int ReadLink  ();	/* (LinkId, Buffer, Count, Timeout); */
extern	int WriteLink ();	/* (LinkId, Buffer, Count, Timeout); */
extern	int ResetLink ();	/* (LinkId); */
extern	int AnalyseLink ();	/* (LinkId); */
extern	int TestError ();	/* (LinkId); */
extern	int TestRead  ();	/* (LinkId); */
extern	int TestWrite ();	/* (LinkId); */
extern  int InfoLink  ();	/* (struct ext_link_info **LinkPtr) */
extern  char *lerror  ();	/* (error_code) */


main (argc, argv)
int argc;
char *argv[];
{	struct ext_link_info *x_link = NULL;
	int no_links;	/* number of links */
	int i;

	printf ("\n%s\n\n%s\n%s\n",
		"Display status about all hardware links to transputers",
		" Id   Status       Link-Name         Bus-Address  SBus-slot",
		"===========================================================");
	if ((no_links = InfoLink (&x_link)) < 0) {
		/* failed to get info about links */
		fprintf (stderr,
		   "\nlinks: Failed to get info about links, because %s\n",
		   lerror (no_links));
		exit (1);
	}
	
	/* display info about each link */
	for (i=0; i < no_links; i++) {
	    if (strncmp(x_link->link_name, "scsi-t", 6) == 0) {
		printf ("%3d   %-10s   %-16s   %s\n",
		   x_link->link_number,
		   (x_link->in_use==0) ? "available" : "IN USE",
		   x_link->link_name, (char*)  x_link->link_address);
	    } else {
		printf ("%3d   %-10s   %-16s   0x%08x  %d\n",
		   x_link->link_number,
		   (x_link->in_use==0) ? "available" : "IN USE",
		   x_link->link_name, (unsigned long) x_link->link_address,
		   x_link->slot_no);
	    }
		x_link++;
	}
	printf ("\n");
}







